//***********************************************
//*                 Main.C                      *
//***********************************************
//* W-AP002 MPLAB C17 Advance Workshop          *
//* Written by: Richard Yang                    *
//*             Sr. Corporate Applications Engr.*
//*             Microchip Technology Inc.       *
//* Date:       16 January 2003                 *
//* Revision:	1                               *
//***********************************************	
//*       
//*         mߤT WVT-100eܷū
//*
//* Wܦb׺ݾreŪӤPAū׷P
//* ū׭ȡANഫASCIIܦb VT100 ׺ݾW
//*     1. קVT100.cHWܤr 
//*     2. קMain.c  T1  T2 ū
//*     3. Main.c Cj 500mS sܪū
    	   
#include "main.h"

//*           wqܼƨéb Access Bank          
//*********************************************************** 
#pragma udata access My_RAM_1

near unsigned char Str_Len;
near unsigned char i;
near unsigned char T1_Buffer;
near unsigned int T2_Buffer ;
near unsigned int Slave_update_Count;

near union
{
	int	Word ;
	unsigned char Byte[2] ;
}Byte2Word ;

near struct
{
	unsigned Timer1_Flag:1;
}Flagbits;

#pragma udata

char ASCII_String[10];

//*           wqLCDܪdréb ROM      
//*********************************************************** 
#pragma romdata RomData
const rom char LCD_ROM_MSG1[ ] =" WAP-002 Exer 3 ";
const rom char LCD_ROM_MSG2[ ] ="T1=    ";
const rom char LCD_ROM_MSG3[ ] ="T2=      ";

const far rom char Degree_C[]=" deg.C   ";					//	VT-100 display Table
#pragma code

//*           wq`Ƹ    
//*********************************************************** 
// (1/32768Hz) * 16384 = 0.5 Sec
#define		Timer_Count		16384				// Set for 500mS @32.768KHz 

//***********************************************************
/*														   											*/
/* 						Main 	Program					   								*/
/*														   											*/
//***********************************************************
void main(void)
{
	InitializePORT( );
	InitializeINTs( );
 	InitializeTMR1( );
	InitializeUSART( );
    Initialize_I2C_Master( );
	InitializeAD( );

	OpenLCD( );
	LCD_Set_Cursor(0,0);
	putrsLCD(LCD_ROM_MSG1);			// Display "WAP-002 Exer3 " on Line 1

	InitializeVT100( );				// Clear Terminal screen & put cursoe on (0,0)	
	VT100_Fill_Screen(0);			// Fill the initialize charactor on VT-100
	VT100_Cursor_Position(8,51);
 	Slave_update_Count=0;

	while(1)
	{
 
//*******************************************************
//*       mߤT@sū LCD & VT100 
//* ˬdO_500mSXwQ]wAsūLCD & VT100
//* O! N500mSXMs
//*******************************************************
		if (Flagbits.Timer1_Flag)	// update Temperature on LCD every 0.5 Sec
		{
???					// Clear Timer1_Flag
					// Update Temperature on LCD
					// Update Temperature on VT100
		}
 	} 
}
 
//***************************************************
//*  The function will update the T1 & T2 on VT100  *
//***************************************************

void VT_100_Update(void)
{
	Slave_update_Count ++;						// Update the Slave Update counter
  	itoa(Slave_update_Count,ASCII_String);		
  	VT100_Cursor_Position(11,39);
	VT100_Clear_Right( );
	putsUSART(ASCII_String);

	VT100_Cursor_Position(13,32);				// Update Temperature 1
	T1_Buffer=Byte2Word.Byte[0];				// Copy T1 to buffer for VT100
 	btoa(T1_Buffer,ASCII_String);
  	putsUSART(ASCII_String);
 	putrsUSART(Degree_C);							 
 	WriteUSART(' ');

	T2_Buffer=Read_TC1047_Temperature( );
	VT100_Cursor_Position(15,32);				// Update Temperature 2
	Print_Temperature(T2_Buffer);
		
}

void Print_Temperature(int Data)
{
	if (Data==0) WriteUSART('0');				// T2 = 0 , Display "0" on LCD
	else
	{
 		itoa(Data,ASCII_String);			  	// Convert to ASCII string
		Str_Len = strlen(ASCII_String);			// Get length for the ASCII-String
		
		for (i=0;i<Str_Len;i++)							
		{
			if (i==(Str_Len-1))					// Looking for the point
			{
				if (Str_Len==1) Print_Byte('0');	// Just one digital, add "0"
				Print_Byte('.');			    // Add the point
			}
		
			Print_Byte(ASCII_String[i]);		// Display the ASCII_String on LCD
		}
	}
 	putrsUSART(Degree_C);
}

void Print_Byte(unsigned char Byte)
{
	while (BusyUSART( ));
	WriteUSART(Byte);
}

//***************************************************
//*    The function will update the T1 & T2 on LCD 	*
//***************************************************
//*          Display LCD format on Line 2  			*
//* " T1=20* T2=101.8* " with auto position scaling *
//***************************************************
void LCD_Temp_Update (void)
{
	//*** Display TC74-A7 Temperature on LCD  ***
	LCD_Set_Cursor(1,0);
	putrsLCD(LCD_ROM_MSG2);							// DIsplay "T1=   "

	LCD_Set_Cursor(1,3);					
	Byte2Word.Word = Read_TC74_Temperature( );  	// Get Current Temperature form TC74-A7

	if ( Byte2Word.Byte[1] == 0 )
	{
		T1_Buffer=Byte2Word.Byte[0];				// Copy T1 to buffer for LCD
		btoa(T1_Buffer,ASCII_String);				// Convert Temp. Hax to ASCII string
  		putsLCD(ASCII_String);						// Print to LCD
		putcLCD(0xDF);							 	// Add degree symbol
	}
 	else if ( Byte2Word.Byte[1] == -1 )					// Read fail from TC74-A7, Display "--" on LCD
  	{
		putcLCD('-') ;		
		putcLCD('-') ;
	}


	//**** Display TC1047A Temperature on LCD  ***
	LCD_Set_Cursor(1,7);
	putrsLCD(LCD_ROM_MSG3);							// DIsplay "T2=   "

	LCD_Set_Cursor(1,10);					 
	T2_Buffer=Read_TC1047_Temperature( );			// Get Current Temperature from TC1047A
	if (T2_Buffer==0) putcLCD('0');
	else
	{
		itoa(T2_Buffer,ASCII_String);				// Convert to ASCII string
		Str_Len = strlen(ASCII_String);				// Get length for the ASCII-String
	
		for (i=0;i<Str_Len;i++)							
		{
			if (i==(Str_Len-1))						// Looking for the point
			{
				if (Str_Len==1) putcLCD('0'); 		// Just one digital, add "0"
				putcLCD('.');				 		// Add the point
			}
			putcLCD(ASCII_String[i]);				// Display the ASCII_String on LCD

		}
	}		
	putcLCD(0xDF);									// Add degree symbol
}

//************************************************
//* Function: isr_low(void)                      *     
//*  - Timer 1 Interrupt for the 500mS Delay     *
//*    for update VT100 terminal				 *            
//************************************************
#pragma interruptlow isr_low 

void isr_low(void)
{

		WriteTimer1(65536-Timer_Count);				// Reload 0.5 Second value to Timer1
		PIR1bits.TMR1IF=0;							// Clear interrupt flag of Timer 1

		Flagbits.Timer1_Flag=1;						// Set for program task 
}								
#pragma code

//************************************************
//* Function: isr_low_direct                    *
//*   - Direct execution to the actual           *
//*     low-priority interrupt code.            *
//************************************************
#pragma code isrlowcode = 0x0018

void isr_low_direct(void)	
{  								
     _asm 				//begin in-line assembly
     goto isr_low		//go to isr_high function
     _endasm 			//end in-line assembly
}
#pragma code

