
//*           ŧiҨϥΪtJ
//***********************************************************
#include <p18f452.h>
#include <delays.h>
#include <stdlib.h>
#include <string.h>
#include <timers.h>
#include <i2c.h>
#include <adc.h>
#include <usart.h>
#include <pwm.h>

//*           ƭ쫬ŧi
//***********************************************************

// Declaration file for Main.c related subroutines 
void LCD_Temp_Update(void) ;
void VT_100_Update(void );
void Print_Temperature(int Data);
void Print_Byte(unsigned char Byte);
void EEPROM_Update(void);
void EE_Write (unsigned char, unsigned char);
unsigned char EE_Read (unsigned char);
void PWM_Control(void);
void isr_high_direct(void);	
void isr_high(void);
void isr_low_direct(void);
void isr_low(void);


// Declaration file for Init_MCU.c related subroutines 

void InitializePORT(void) ;
void InitializeTMR1(void) ;
void InitializeINTs(void) ;
void InitializeAD(void) ;
void InitializeUSART(void );
void Initialize_I2C_Master(void);
void InitializeTMR2(void);
void InitializePWM(void);

// Declaration file for WAP_LCD.c related subroutines 

void	OpenLCD (void) ;
void	WriteCmdLCD ( unsigned char ) ;
void	WriteDataLCD( unsigned char ) ;
void 	putsLCD( char * ) ;
void	putrsLCD( const rom char * ) ;
void	putcLCD( unsigned char ) ;
void	puthexLCD( unsigned char ) ;
void	LCD_Set_Cursor( unsigned char , unsigned char ) ;
void	LCD_CMD_W_Timing( void ) ;
void	LCD_L_Delay( void ) ;
void	LCD_S_Delay( void ) ;
void	LCD_DAT_W_Timing ( void ) ;

// Declaration file for Read_Temp.c related subroutines 

unsigned 	Read_TC74_Temperature(void) ;
int			Read_TC1047_Temperature( void);

// Declaration file for VT100.c related subroutines 

void VT100_puthex(unsigned char);
void VT100_Fill_Screen(unsigned char);
void InitializeVT100(void);
void VT100_ESC(void);
void VT100_Clear_Screen(void);
void VT100_Clear_Right (void );
void VT100_Clear_Line (void);
void VT100_Cursor_Up (unsigned char Xn);
void VT100_Cursor_Down (unsigned char Xn);
void VT100_Cursor_Right (unsigned char Yn);
void VT100_Cursor_Left (unsigned char Yn);
void VT100_Cursor_Position (unsigned char Xn, unsigned char Yn);
void VT100_Cursor_Index (void);
void VT100_Cursor_R_Index (void);
void VT100_Cursor_Home (void);
void VT100_Cursor_N_Line (void);

// Declaration file for Rec_Cmd.c related subroutines 

void Rec_Cmd_Check(void);
void Modify_T2_Max(void);
void Modify_T2_Min(void);
void Cooling_Auto(void);
void Cooling_Shutdown(void);
int Get_3_Digital(void);
